// vars
var pluginRootFolder = '/plugins/SPX_ExtensionDevExample/'
var CONFIGDATA

document.onkeydown = checkKey;
function checkKey(e) {
    // This will prevent the use spx-gc.js checkKey() -function
    // and does not interfere with spaces, for example.
    return;
} // checkKey

function sendCmd(cmd, regionNro='', text1='', text2='') {
    let data           = {};
    data.relpath       = CONFIGDATA.template.file;
    data.playserver    = CONFIGDATA.template.server;
    data.playchannel   = CONFIGDATA.template.channel;
    data.playlayer     = CONFIGDATA.template.layer;
    data.webplayout    = CONFIGDATA.template.layer;
    data.relpathCCG    = data.relpath.split('.htm')[0];
    data.fields        = [];
;
    switch (cmd) {
        case 'play':
            data.fields  = [
                { field: 'f0', value: e('headline').value },
                { field: 'f1', value: e('numbBtn').innerText },
                { field: 'f2', value: e('footer').value },
            ]
            data.command = 'play';
            ajaxpost('/gc/playout', data);
            break;
            
        case 'stop':
            data.command = 'stop';
            ajaxpost('/gc/playout', data);
            break;
    
        case 'incrementNumber':
            let numberValue = parseInt(e('numbBtn').innerText);
            numberValue++;
            e('numbBtn').innerText = numberValue;
            data.command = 'invoke';
            console.log('Triggering template function updateGfx(' + numberValue+ ').');
            data.invoke  = "updateGfx('" + numberValue + "')";
            ajaxpost('/gc/playout', data);
            break;

        default:
            break;
    }
} // sendCmd

function ajaxpost(urlPath, data) {
    // SPX needs to know the data is prepopulated
    console.log('ajaxpost', urlPath, data);
    data.prepopulated="true" 
    axios.post(urlPath, data)
    .then(function (response) {
        // console.log(response.data);
    })
    .catch(function (error) {
        if (error.response) {
            console.log(error.response.data);
            console.log(error.response.status);
            console.log(error.response.headers);
        } else if (error.request) {
            console.log(error.request);
        } else {
          console.log('Error', error.message);
        }
        console.log(error.config);
      });
} //ajaxpost

async function createUI() {
    try {
        window.moveTo(CONFIGDATA.general.left,CONFIGDATA.general.top);
        window.resizeTo(CONFIGDATA.general.width,CONFIGDATA.general.height);
        document.title = "SPX Extension | " + CONFIGDATA.general.title;
        e('playBtn').addEventListener('click', () => { sendCmd('play'); });
        e('stopBtn').addEventListener('click', () => { sendCmd('stop'); });
        e('numbBtn').addEventListener('click', () => { sendCmd('incrementNumber'); });
        return true
    } catch (error) {
        console.error('Error! ', error);
        return false
    }
 } // createUI

function e(ID) {
    return document.getElementById(ID);
} // e

window.addEventListener('load', async () => {
    console.clear()
    try {
        fetch(pluginRootFolder + 'extension_config.json')
            .then(response => {
                // console.log('Config was read')
                return response.json();
            })
            .then(response => {
                // console.log('Config was turned to JSON')
                CONFIGDATA = response;
                console.log('CONFIG', CONFIGDATA);
            })
            .then(dataResult => {
                // console.log('Next createUI...')
                createUI()
            })
            .then(uicreated => {
                // console.log('UI was created')
            })
            .catch(error => {
                throw new Error('Something failed', error);
            });
    } catch (error) {
        console.error('HOUSTON!', error)
    }
}); // load event listener




